/* copyright (c)2013 Oskar Schirmer <oskar@scara.com> */
#include "chanend.h"
#include "dispatch.h"
#include "ethernet.h"
#include "execuser.h"
#include "print.h"
#include "reception.h"
#include "resource.h"
#include "uart.h"

#define HISTO_SIZE 256

void testchannel(resource control)
{
  int i;
  unsigned u, v;
  resource l, s, ctrl, t;
  unsigned histo[HISTO_SIZE];
  unsigned count[HISTO_SIZE];
  unsigned cntat[HISTO_SIZE];
  unsigned cnt = 0;
  l = chanend_book();
  chanend_destination(l, chanend_cr_request(l, cr_uart_tx));
  s = chanend_book();
  printstr(l, "Look from ");
  printhex(l, s, 8);
  println(l);
  ctrl = execuser("testchannelmirror");
  for (i = 0; i < HISTO_SIZE; i++) {
    histo[i] = 0;
  }
  chanend_connect(s, ctrl);
  t = timer_book();
  timer_watch(t);
  u = timer_read(t);
  for (i = 0; i < (1 << 20); i++) {
    u += 4 * HISTO_SIZE;
    timer_alarm(t);
    timer_set(t, u);
    timer_read(t);
    chanend_write_byte(s, 0);
    timer_watch(t);
    chanend_read_byte(s);
    v = timer_read(t) - u;
    if (v >= HISTO_SIZE) {
      if (cnt < HISTO_SIZE) {
        cntat[cnt] = i;
        count[cnt] = v;
        cnt += 1;
      }
      v = HISTO_SIZE - 1;
    }
    histo[v] += 1;
  }
  chanend_hangup(s);
  chanend_free(s);
  timer_free(t);
  for (i = 0; i < HISTO_SIZE; i++) if (histo[i]) {
    printstr(l, "Histo[");
    printhex(l, i, 4);
    printstr(l, "] = ");
    printhex(l, histo[i], 8);
    println(l);
  }
  for (i = 0; i < cnt; i++) {
    printstr(l, "Count[");
    printhex(l, cntat[i], 8);
    printstr(l, "] = ");
    printhex(l, count[i], 8);
    println(l);
  }
  chanend_free(l);
}
