/* copyright (c)2013 Oskar Schirmer <oskar@scara.com> */
#include "print.h"
#include "reception.h"
#include "resource.h"
#include "uart.h"

#define FREQ (time_per_second / 1000000)

void testportio(resource control)
{
  resource p, t;
  int i;
  unsigned u;
  resource log;
  log = chanend_book();
  chanend_destination(log, chanend_cr_request(log, cr_uart_tx));
  p = port_book(1, 9); /* P1K0 XnD34 */
  port_on(p);
  port_write(p, 1);
  t = timer_book();
  timer_watch(t);
  u = timer_read(t);
  timer_alarm(t);
  for (i = 0; i < (1 << 16); i++) {
    u += FREQ / 2;
    timer_set(t, u);
    timer_read(t);
    port_write(p, 0);
    u += FREQ / 2;
    timer_set(t, u);
    timer_read(t);
    port_write(p, 1);
  }
  timer_free(t);
  port_free(p);
  printstr(log, "Signal: done");
  println(log);
  chanend_free(log);
}
